# graf
graph = {}
graph["start"] = {}
graph["start"]["a"] = 6
graph["start"]["b"] = 2

graph["a"] = {}
graph["a"]["fin"] = 1

graph["b"] = {}
graph["b"]["a"] = 3
graph["b"]["fin"] = 5

graph["fin"] = {}

# tablica kosztw
infinity = float("inf")
costs = {}
costs["a"] = 6
costs["b"] = 2
costs["fin"] = infinity

# tablica rodzicw
parents = {}
parents["a"] = "start"
parents["b"] = "start"
parents["fin"] = None

processed = []

def find_lowest_cost_node(costs):
    lowest_cost = float("inf")
    lowest_cost_node = None
    # przeglda kady wze po kolei
    for node in costs:
        cost = costs[node]
        # Jeli jest to najniszy z dotychczasowych kosztw i nie zosta jeszcze przetworzony...
        if cost < lowest_cost and node not in processed:
            # ...ustaw go jako nowy najtaszy wze.
            lowest_cost = cost
            lowest_cost_node = node
    return lowest_cost_node

# Znajduje najtaszy wze, ktry jeszcze nie zosta przetworzony.
node = find_lowest_cost_node(costs)
# Jeli przetworzono wszystkie wzy, ptla koczy dziaanie.
while node is not None:
    cost = costs[node]
    # Przeglda wszystkich ssiadw danego wza.
    neighbors = graph[node]
    for n in neighbors.keys():
        new_cost = cost + neighbors[n]
        # Jeli dotarcie do tego ssiada jest tasze drog przez ten wze...
        if costs[n] > new_cost:
            # ...zaktualizuj koszt tego wza.
            costs[n] = new_cost
            # Wze ten staje si nowym rodzicem tego ssiada.
            parents[n] = node
    # Oznaczenie wza jako przetworzonego.
    processed.append(node)
    # Znajduje nastpny wze do przetworzenia i wraca na pocztek ptli.
    node = find_lowest_cost_node(costs)

print "Koszt od pocztku do kadego wza:"
print costs

